/*---------------------------------------------------------------------------------
  File........: lotusmail.p
  Version.....: 1.0
  Description : Send Email from Lotus Notes with or without attachments
  Input Param : <MAIL-RECIPIENT>, <MAIL-SUBJECT>, <MAIL-BODY>, <ATTACHMENT-FILE>,
  Output Param: <MAIL-OPERATION-SUCCESS>
  Author......: Sam Schroeder - The Instant Companies - (952) 470-3252
  Contact Info: samuel.schroeder@iwco.com - (952) 470-3252
  Copyright...: FreeFramework 2001 - http://www.freeframework.org
  Created.....: 08/07/2001
  Notes.......: An active Lotus Notes session needs to be running on the machine
                the executes this code.  This means that a "user" needs to be logged
                into Notes as well.  If not attachment is needed then send "" as the
                parameter.
  Dev Notes...: 08/07/2001 - SJS - Created, based on code from Ricardo A. Manfredini
----------------------------------------------------------------------------------*/

/* Parameters */
DEFINE INPUT  PARAMETER ipcRecipient   AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER ipcMailSubject AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER ipcMailBody    AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER ipcAttachment  AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER oplMailSuccess AS LOGICAL    NO-UNDO.

/* Variables */
DEFINE VARIABLE cLogFile         AS CHARACTER   NO-UNDO.
DEFINE VARIABLE objDB            AS COM-HANDLE  NO-UNDO.
DEFINE VARIABLE objDoc           AS COM-HANDLE  NO-UNDO.
DEFINE VARIABLE objItem          AS COM-HANDLE  NO-UNDO.
DEFINE VARIABLE objSession       AS COM-HANDLE  NO-UNDO.
DEFINE VARIABLE iEmbedAttachment AS INTEGER     NO-UNDO.

/* Preprocessors */
&SCOPED-DEFINE ADDTOLOG PUT UNFORMATTED CHR(10) TODAY "|" STRING(TIME,"HH:MM:SS") "|"

/* Lotus Parameters */
ASSIGN iEmbedAttachment = 1454.

/* Open LogFile */
ASSIGN cLogFile = "lotusmail.log".
OUTPUT TO VALUE(cLogFile) APPEND.

CREATE "NOTES.NOTESSESSION" objSession.

/* Check to see if we are logged into notes */
/* We are NOT logged in */
IF objSession:CurrentDatabase EQ 0 THEN
DO:
  {&ADDTOLOG} "Local Computer not logged into Notes".
  ASSIGN oplMailSuccess = FALSE.
  RETURN.
END. /* Not Logged in */

/* We ARE logged in */
ASSIGN objDB   = objSession:CURRENTDATABASE
       objDoc  = objDB:CREATEDOCUMENT
       objItem = objDoc:CreateRichTextItem("IS-FILE").

/* Skip if no attachment */
IF ipcAttachment NE "" THEN
DO:
  /* Check for the file's existance */
  IF SEARCH(ipcAttachment) = ? THEN
  DO:
    {&ADDTOLOG} "Could not find file: " ipcAttachment.
    ASSIGN oplMailSuccess = FALSE.
    RETURN.
  END. /* File Not Found */

  /* Actually Add The Attachment */
  objItem:EMBEDOBJECT(iEmbedAttachment, 0, ipcAttachment).
END.
  

/* Create Email */
ASSIGN objDoc:SendTo  = ipcRecipient
       objDoc:Subject = ipcMailSubject
       objDoc:Body    = ipcMailBody
       objDoc:IS-CODE = "IS Department Mail".

/* Send the Email */
objdoc:SAVE(TRUE, FALSE).
objdoc:SaveMessageOnSend = TRUE.
objdoc:SEND(FALSE, ipcRecipient).

/* Log Successful Operation */
/* You might want to comment this if you are sending large volumes of mail */
{&ADDTOLOG} "Mail sent to: " ipcRecipient ", with attachment: " ipcAttachment. 
ASSIGN oplMailSuccess = TRUE.

/* Close Log File */
OUTPUT CLOSE.

/* Release the Notes Objects */
RELEASE OBJECT objItem    NO-ERROR.
RELEASE OBJECT objDoc     NO-ERROR.
RELEASE OBJECT objDB      NO-ERROR.
RELEASE OBJECT objSession NO-ERROR.

